use PPI;
use PPI::Dumper;

use Compiler::Lexer;
use Compiler::Parser;
use Compiler::Parser::AST::Renderer;

my $source_code = do { local $/; <DATA> };

print "------ PPIの出力結果 ------\n";
my $document = PPI::Document->new(\$source_code);
PPI::Dumper->new($document)->print;

print "------ Compiler::Parserの出力結果 ------\n";
my $lexer  = Compiler::Lexer->new;
my $tokens = $lexer->tokenize($source_code);
my $ast    = Compiler::Parser->new->parse($tokens);
Compiler::Parser::AST::Renderer->new->render($ast);

__DATA__
use Try::Tiny;
my $result = try {
    my $response = do_something;
    return $response;
} catch {
    warn 'throw exception';
};
