use strict;
use warnings;
use Compiler::Lexer;
use Compiler::Parser;
use Compiler::CodeGenerator::LLVM;

my $code      = do { local $/; <DATA> };
my $tokens    = Compiler::Lexer->new->tokenize($code);
my $ast       = Compiler::Parser->new->parse($tokens);
my $generator = Compiler::CodeGenerator::LLVM->new();
my $llvm_ir   = $generator->generate($ast);
print $llvm_ir, "\n";

__DATA__
print "hello world\n";
